package flock;

import java.awt.event.*;
import java.awt.*;
import java.util.*;

class MainPanel extends Panel{

	static MainPanel mainPanel;
	
	MainPanel(){
		mainPanel = this;
		Primitive.loadImage(".\\images\\leaf.gif");
		
		
		MouseDispatcher mouseDispatcher = new MouseDispatcher();
		addMouseListener(mouseDispatcher);
		addMouseMotionListener(mouseDispatcher);
		addKeyListener(mouseDispatcher);
		
		clear();
	}
	
	
	
	
	//
	//  `揈
	//
	
	Image buffered_image = null;
	public void update(Graphics g) {
		paint(g);
	}
	public void paint(Graphics g) {

		//double buffering
		if (buffered_image == null)
			buffered_image = createImage(getSize().width, getSize().height);
		Graphics bg = buffered_image.getGraphics();

		// clear
		bg.setColor(Color.white);
		bg.fillRect(0,0, getSize().width, getSize().height);
			
		// paint code main
		draw_primitives(bg);
		
		
		//double buffering
		bg.dispose();
     
		g.drawImage(buffered_image,0,0,this);
	}
	
	ArrayList primitives = new ArrayList();
	
	void draw_primitives(Graphics g){
		for(int i=0; i<primitives.size(); i++){
			Primitive primitive = (Primitive) primitives.get(i);
			primitive.draw(g);
		}
		
		g.setColor(Color.black);
		g.drawString("count: "+primitives.size(), 10, 15);
	}
	
	
	
	
	
	
	
	
	
	
	
	//
	// event handling
	//
	Primitive current_primitive = null;
	public boolean start_dragging(Point p){
		current_primitive = pick_primitive(p);
		if (current_primitive == null)
			return false;
		prev_p = p;
		return true;
	}
	Point prev_p;
	public void dragging(Point p){
		if (current_primitive == null)
			return;
		
		current_primitive.move_relative(p.x-prev_p.x, p.y-prev_p.y);
		
		prev_p = p;
		repaint();
	}
	public void finish_dragging(Point p){
	}
	

	
	Primitive pick_primitive(Point p){
		Primitive picked_primitive = null;
		for(int i=primitives.size()-1; i>=0; i--){
			Primitive primitive = (Primitive) primitives.get(i);
			if (primitive.picked(p)){
				picked_primitive = primitive;
				break;
			}
		}
		return picked_primitive;
	}
	
	
	public void clear(){
		primitives = new ArrayList();
		primitives.add(new Primitive());
		repaint();
	}
	
	
	
	
	public void loadImage(){
		java.awt.FileDialog fileDialog = new java.awt.FileDialog( Main.f, "Load Image", java.awt.FileDialog.LOAD );
		fileDialog.setDirectory(".\\images\\");
		fileDialog.setFile("*.gif");
		fileDialog.setVisible(true);
		if( fileDialog.getFile()!=null )
		{
			clear();
			String filename = fileDialog.getDirectory() + fileDialog.getFile();
			Primitive.loadImage(filename);
			repaint();
		}
		fileDialog.dispose();
		
	}
	
	
	
	
	
	

	
	
	
	
   
	
	public int operation_status;
	public static final int NONE = 0;
	public static final int DRAGGING = 1;
   
	//   
	// event dispatcher
	//
	public class MouseDispatcher 
		extends MouseAdapter implements MouseMotionListener, KeyListener{

		boolean right_button = false;
		
  		public void mouseMoved(MouseEvent e) {
  		}
  		public void mousePressed(MouseEvent e) {
			Point p = e.getPoint();
			right_button = (e.getModifiers() & e.BUTTON3_MASK) != 0;
			
			if (start_dragging(p))
				operation_status = DRAGGING;
			else
				operation_status = NONE;
		}
  		public void mouseDragged(MouseEvent e) {
			Point p = e.getPoint();
			
			switch(operation_status){
			case DRAGGING:
				dragging(p);
				break;
			}
			
   		}
		public void mouseReleased(MouseEvent e) {
			Point p = e.getPoint();
			
			switch(operation_status){
			case DRAGGING:
				finish_dragging(p);
				break;
			}
			
			operation_status = NONE;
		}
		public void mouseClicked(MouseEvent e){
			Point p = e.getPoint();
			
			if (!right_button)
				return;
			current_primitive = pick_primitive(p);
			if (current_primitive != null)
				current_primitive.show_popupmenu(p.x, p.y);
		
		}
		
		
		public void keyPressed(KeyEvent e){
			int key_code = e.getKeyCode();
			if (key_code == e.VK_D && (e.CTRL_MASK & e.getModifiers()) != 0){
				if (current_primitive != null)
					current_primitive.duplicate();
			}
			
			repaint();
		}
		public void keyTyped(KeyEvent e){}
		public void keyReleased(KeyEvent e){}
		
    }
	
	
	
	
	
	
}







